/* tde95d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

int main(void)
{
    /* Builtin functions */
    double exp(double), cos(double), sin(double);

    /* Local variables */
    extern int de95d_c(U_fp, U_fp, U_fp, int *, double *, double *,
                       double *, double *, double *, double *, double *,
                       double *, double *, int *);
    static double hmin;
    static int ierr;
    extern int f_c();
    static double h__;
    static int m;
    static double p, r__[93], y[4];
    static float y1, y2, y3, y4;
    extern int fj_c();
    static int ih;
    extern int fx_c();
    static double xk, xn, yn[4], eps;

    m = 4;
    xn = 0.;
    yn[0] = 10.;
    yn[1] = 11.;
    yn[2] = 111.;
    yn[3] = 111.;
    hmin = 1e-10;
    eps = .01;
    p = 1e3;
    xk = 10.;
/*  BCEHE TOHOO PEEH CCTEM: */
    y1 = exp(xk * -100.) * 10.;
    y2 = y1 + exp(-xk) * (cos(xk) + sin(xk));
    y3 = y2 + exp(xk * -1e4) * 100. * cos(xk * 10.);
    y4 = y3 + exp(xk * -1e4) * 100. * sin(xk * 10.);

    printf("\n %24.14e %24.14e ", y1, y2);
    printf("\n %24.14e %24.14e \n", y3, y4);
    ih = 0;
L10:
    ++ih;
    h__ = .01;
    de95d_c((U_fp)f_c, (U_fp)fj_c, (U_fp)fx_c, &m, &xn, yn, &xk, &hmin, &eps, &p,
            &h__, y, r__, &ierr);

    printf("\n %24.14e \n", eps);
    printf("\n %24.14e %24.14e ", y[0], y[1]);
    printf("\n %24.14e %24.14e \n", y[2], y[3]);
    printf("\n %24.14e \n", h__);
    eps *= .01;
    if (ih < 3) {
        goto L10;
    }
    return 0;
} /* main */

int f_c(double *x, double *y, double *dy, int *m)
{
    /* Builtin functions */
    double exp(double), cos(double);

    /* Local variables */
    static double t1;

    /* Parameter adjustments */
    --dy;
    --y;

    /* Function Body */
    dy[1] = y[1] * -100.;
    t1 = exp(*x * -100.) * 20. + exp(-(*x)) * 2. * cos(*x);
    dy[2] = dy[1] - y[2] * 2. + t1;
    dy[3] = dy[1] + y[2] * 9998. - y[3] * 9990. - y[4] * 10. + t1;
    dy[4] = dy[1] + y[2] * 9988. + y[3] * 20. - y[4] * 10010. + t1;
    return 0;
} /* f_c */

int fj_c(double *x, double *y, double *df, int *m)
{
#define df_ref(a_1,a_2) df[(a_2)*4 + a_1]

    /* Parameter adjustments */
    df -= 5;
    --y;

    /* Function Body */
    df_ref(1, 1) = -100.;
    df_ref(1, 2) = 0.;
    df_ref(1, 3) = 0.;
    df_ref(1, 4) = 0.;
    df_ref(2, 1) = -100.;
    df_ref(2, 2) = -2.;
    df_ref(2, 3) = 0.;
    df_ref(2, 4) = 0.;
    df_ref(3, 1) = -100.;
    df_ref(3, 2) = 9998.;
    df_ref(3, 3) = -9990.;
    df_ref(3, 4) = -10.;
    df_ref(4, 1) = -100.;
    df_ref(4, 2) = 9988.;
    df_ref(4, 3) = 20.;
    df_ref(4, 4) = -10010.;
    return 0;
} /* fj_c */

#undef df_ref

int fx_c(double *x, double *y, double *dx, int *m)
{
    /* Builtin functions */
    double exp(double), cos(double), sin(double);

    /* Parameter adjustments */
    --dx;
    --y;

    /* Function Body */
    dx[1] = 0.;
    dx[2] = exp(*x * -100.) * -2e3 - exp(-(*x)) * 2. * (cos(*x) + sin(*x));
    dx[3] = dx[2];
    dx[4] = dx[2];
    return 0;
} /* fx_c */
